#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

uniform float shadowDirectionFactorX;
uniform float shadowDirectionFactorY;

void main(void)
{
    vec2 unit = 1.0 / resolution.xy;
    
    vec4 col = vec4(0);
    
    int rInt = int(blurRadius*0.2);
    float r = float(rInt);
    float count = 0.0;
    float weight;
    int x,y;
    
    for(x = rInt; x >= -rInt; x--)
    {
        for(y = rInt; y >= -rInt; y--)
        {
            weight = 0.0175*(3.0 * r - abs(3.0 * float(x))) * (3.0 * r - abs(3.0 * float(y)));
            vec4 color = texture2D(CC_Texture0, v_texCoord + vec2(3.0 * float(x) * unit.x, 3.0 * float(y) * unit.y));
            color.a=color.a*0.625;
            col += color * weight;
            count += weight;
        }
    }
    
    gl_FragColor = vec4(col / count);
    
    gl_FragColor.r=0.0;
    gl_FragColor.g=0.0;
    gl_FragColor.b=0.0;
    
    //
    
    int shadowSize = int(blurRadius*0.75);
    
    for(x=0;x<shadowSize;x++)
    {
        col = texture2D(CC_Texture0,  v_texCoord + vec2(float(x) * unit.x * shadowDirectionFactorX, float(x) * unit.y * shadowDirectionFactorY));
    
        if(col.a==1.0)
        {
            gl_FragColor.a=gl_FragColor.a+0.1+(float(shadowSize-x)/float(shadowSize))*0.15;
            break;
        }
    }
}
