#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    vec2 unit = 1.0 / resolution.xy;
    
    if(texColor.a > 0.0)
    {
        vec4 col = vec4(0);
        float r = blurRadius*0.1;
        float sampleStep = r *0.05;
        
        for(float x = -r; x <= r; x += sampleStep)
        {
            for(float y = -r; y <= r; y += sampleStep)
            {
                vec4 texColor2 = texture2D(CC_Texture0, v_texCoord + vec2(x * unit.x, y * unit.y));
                texColor2.a = 1.0-texColor2.a;
                col += texColor2;
            }
        }
    
        if(col.a > 0.0)
        {
            col = vec4(0,0,0,1.5);
        }
        
        gl_FragColor = (texColor*texColor.a + col*col.a)/(col.a+texColor.a);
        gl_FragColor.a = 1.0;
        
        //
        
        col = vec4(0);
        r = blurRadius*0.2;
        sampleStep = r *0.05;

        for(float x = -r; x <= r; x += sampleStep)
        {
            for(float y = -r; y <= r; y += sampleStep)
            {
                vec4 texColor2 = texture2D(CC_Texture0, v_texCoord + vec2(x * unit.x, y * unit.y));
                texColor2.a = 1.0-texColor2.a;
                col += texColor2;
            }
        }

        if(col.a > 0.0)
        {
            col = vec4(0,0,0,0.25);
        }
        
        gl_FragColor = (gl_FragColor*gl_FragColor.a + col*col.a)/(col.a+gl_FragColor.a);
        gl_FragColor.a = 1.0;
        
        //
        
        col = vec4(0);
        r = blurRadius*0.3;
        sampleStep = r *0.05;
        
        for(float x = -r; x <= r; x += sampleStep)
        {
            for(float y = -r; y <= r; y += sampleStep)
            {
                vec4 texColor2 = texture2D(CC_Texture0, v_texCoord + vec2(x * unit.x, y * unit.y));
                texColor2.a = 1.0-texColor2.a;
                col += texColor2;
            }
        }
        
        if(col.a > 0.0)
        {
            col = vec4(0,0,0,0.15);
        }
        
        gl_FragColor = (gl_FragColor*gl_FragColor.a + col*col.a)/(col.a+gl_FragColor.a);
        gl_FragColor.a = 1.0;
    }
    else
    {
        gl_FragColor = texColor;
    }
    
}

